'----------------------------------------------------------------------------
'
' Gouraud-Shading and Matrix Calculation Demo...
'
' Coded by Bobby3999 with the CosmoX Graphics Library v1.2
' E-Mail : bobby3999@yahoo.com
' Url : www.cosmosoft.cjb.net
'                                       (c) CosmoSoft 2001
'
' Compiled with QuickBasic 4.5 and CosmoX v1.2
'
' Note:
' I didn't use the library EMS calls to create the off screen layer because
' I also work on a Windows NT machine, and I can't make it to give me other
' than XMS and conventional memory.
'
'----------------------------------------------------------------------------
  DECLARE SUB ExitToDos ()
  DECLARE SUB Intro ()
  REM $INCLUDE: 'COSMOX.BI'

  TYPE FaceType
    P1 AS INTEGER
    P2 AS INTEGER
    P3 AS INTEGER
    P4 AS INTEGER
  END TYPE

  REM $DYNAMIC
  DIM SHARED Buffer%(32766), Sine!(360), Cosine!(360)
  DIM SHARED Vectors(7) AS Vector3DType, VectorsT(7) AS Vector3DType
  DIM SHARED UnitVectors(7) AS Vector3DType, UnitVectorsT(7) AS Vector3DType
  DIM SHARED Points(7) AS Vector2DType, TMatrix!(3, 3), Matrix!(3, 3)
  DIM SHARED Faces(5) AS FaceType, LightVector AS Vector3DType
  DIM SHARED AngleX%, AngleY%, Font AS STRING * 2048

  Layer% = VARSEG(Buffer(0))
  TMS% = VARSEG(TMatrix!(0, 0))
  TMO% = VARPTR(TMatrix!(0, 0))
  MS% = VARSEG(Matrix!(0, 0))
  MO% = VARPTR(Matrix!(0, 0))

  LightVector.X = 0
  LightVector.Y = 0
  LightVector.Z = -1

  FOR I% = 0 TO 360
    Ang! = I% * (3.141592 / 180)
    Sine!(I%) = SIN(Ang!)
    Cosine!(I%) = COS(Ang!)
  NEXT

  FOR I% = 0 TO 7
    READ Vectors(I%).X
    READ Vectors(I%).Y
    READ Vectors(I%).Z
  NEXT

  FOR I% = 0 TO 5
    READ Faces(I%).P1
    READ Faces(I%).P2
    READ Faces(I%).P3
    READ Faces(I%).P4
  NEXT

  FOR I% = 0 TO 7
    READ UnitVectors(I%).X
    READ UnitVectors(I%).Y
    READ UnitVectors(I%).Z
  NEXT

  CSInitVGA
  DUMMY% = CSInstallKeyBoard
  CSInstallTimer
  IF CSLoadFont("DEMO.FNT", Font) = 0 THEN CSSetFont Font
  CSSetCol 255, 63, 63, 63: CSGradientPal 0, 255
  Intro

  CSSetTimer 0, 20: CSSetTimer 1, 1000
  DO
    CSIdentityMatrix TMS%, TMO%
    CSInitRotXMatrix MS%, MO%, Cosine!(AngleX%), Sine!(AngleX%)
    CSMatrixMulMatrix TMS%, TMO%, MS%, MO%
    CSInitRotYMatrix MS%, MO%, Cosine!(AngleY%), Sine!(AngleY%)
    CSMatrixMulMatrix TMS%, TMO%, MS%, MO%

    FOR I% = 0 TO 7
      CSVectorMulMatrix VARSEG(Vectors(I%).X), VARPTR(Vectors(I%).X), TMS%, TMO%, VARSEG(VectorsT(I%).X), VARPTR(VectorsT(I%).X)
      CSVectorMulMatrix VARSEG(UnitVectors(I%).X), VARPTR(UnitVectors(I%).X), TMS%, TMO%, VARSEG(UnitVectorsT(I%).X), VARPTR(UnitVectorsT(I%).X)
    NEXT
    FOR I% = 0 TO 7
      IF VectorsT(I%).Z = 0 THEN VectorsT(I%).Z = 1
      CSProjectVector VARSEG(VectorsT(I%).X), VARPTR(VectorsT(I%).X), VARSEG(Points(I%).X), VARPTR(Points(I%).X), -500
    NEXT

    CSWaitTimer 0
    FrameCount% = FrameCount% + 1
    CSPcopy Layer%, VIDEO
    CSClear Layer%, 0
    FOR I% = 0 TO 5
      IF CSPolyFacing(VARSEG(Points(Faces(I%).P1)), VARPTR(Points(Faces(I%).P1)), VARSEG(Points(Faces(I%).P2)), VARPTR(Points(Faces(I%).P2)), VARSEG(Points(Faces(I%).P3)), VARPTR(Points(Faces(I%).P3))) < 0 THEN
        Dot1! = CSVectorDot(VARSEG(LightVector.X), VARPTR(LightVector.X), VARSEG(UnitVectorsT(Faces(I%).P1).X), VARPTR(UnitVectorsT(Faces(I%).P1).X))
        Dot2! = CSVectorDot(VARSEG(LightVector.X), VARPTR(LightVector.X), VARSEG(UnitVectorsT(Faces(I%).P2).X), VARPTR(UnitVectorsT(Faces(I%).P2).X))
        Dot3! = CSVectorDot(VARSEG(LightVector.X), VARPTR(LightVector.X), VARSEG(UnitVectorsT(Faces(I%).P3).X), VARPTR(UnitVectorsT(Faces(I%).P3).X))
        Dot4! = CSVectorDot(VARSEG(LightVector.X), VARPTR(LightVector.X), VARSEG(UnitVectorsT(Faces(I%).P4).X), VARPTR(UnitVectorsT(Faces(I%).P4).X))
        IF Dot1! < 0 THEN Dot1! = 0: IF Dot1! > 1 THEN Dot1! = 1
        IF Dot2! < 0 THEN Dot2! = 0: IF Dot2! > 1 THEN Dot2! = 1
        IF Dot3! < 0 THEN Dot3! = 0: IF Dot3! > 1 THEN Dot3! = 1
        IF Dot4! < 0 THEN Dot4! = 0: IF Dot4! > 1 THEN Dot4! = 1
        Col1% = INT(Dot1! * 255): Col2% = INT(Dot2! * 255)
        Col3% = INT(Dot3! * 255): Col4% = INT(Dot4! * 255)
        CSTriG Layer%, Points(Faces(I%).P1).X, Points(Faces(I%).P1).Y, Col1%, Points(Faces(I%).P2).X, Points(Faces(I%).P2).Y, Col2%, Points(Faces(I%).P3).X, Points(Faces(I%).P3).Y, Col3%
        CSTriG Layer%, Points(Faces(I%).P1).X, Points(Faces(I%).P1).Y, Col1%, Points(Faces(I%).P4).X, Points(Faces(I%).P4).Y, Col4%, Points(Faces(I%).P3).X, Points(Faces(I%).P3).Y, Col3%
      END IF
    NEXT
    CSPrintShadow Layer%, CENTERED, 10, "FPS =" + STR$(FPS%), 255, 0
    CSPrintShadow Layer%, 0, 190, CSId, 255, 0
    
    IF CSTimerFlag(1) THEN FPS% = FrameCount%: FrameCount% = 0
   
    IF CSKey(KEYUP) THEN AngleX% = AngleX% + 1
    IF CSKey(KEYDOWN) THEN AngleX% = AngleX% - 1
    IF CSKey(KEYLEFT) THEN AngleY% = AngleY% + 1
    IF CSKey(KEYRIGHT) THEN AngleY% = AngleY% - 1
    IF AngleX% > 360 THEN AngleX% = 0
    IF AngleX% < 0 THEN AngleX% = 360
    IF AngleY% > 360 THEN AngleY% = 0
    IF AngleY% < 0 THEN AngleY% = 360
  LOOP WHILE CSKey(KEYESC) <> 1

  ExitToDos

'Cube vertexes
DATA -50, 50,-50
DATA  50, 50,-50
DATA  50,-50,-50
DATA -50,-50,-50
DATA -50, 50, 50
DATA  50, 50, 50
DATA  50,-50, 50
DATA -50,-50, 50

'Face indexes
DATA 0, 1, 2, 3
DATA 1, 5, 6, 2
DATA 5, 4, 7, 6
DATA 4, 0, 3, 7
DATA 4, 5, 1, 0
DATA 3, 2, 6, 7

'Point Normals
DATA -0.55735, 0.57735,-0.57735
DATA  0.57735, 0.57735,-0.57735
DATA  0.57735,-0.57735,-0.57735
DATA -0.57735,-0.57735,-0.57735
DATA -0.57735, 0.57735, 0.57735
DATA  0.57735, 0.57735, 0.57735
DATA  0.57735,-0.57735, 0.57735
DATA -0.57735,-0.57735, 0.57735

SUB ExitToDos

  CSFadeTo 0, 255, 63, 63, 63
  DUMMY% = CSRemoveKeyBoard
  CSRemoveTimer
  CSInitText
  CLS
  PRINT "Gouraud-Shading and Matrix Calculation Demo..."
  PRINT "Coded by Bobby3999 with the CosmoX Graphics Library v1.2"
  PRINT "E-Mail : bobby3999@yahoo.com"
  PRINT "Url : www.cosmosoft.cjb.net"
  PRINT "                                      (c) CosmoSoft 2001"
  END

END SUB

REM $STATIC
SUB Intro

  CSTriG VIDEO, 0, 0, 255, 320, 0, 0, 0, 200, 0
  CSTriG VIDEO, 320, 0, 0, 320, 200, 255, 0, 200, 0
  CSPrintShadow VIDEO, CENTERED, 50, "CosmoX Gouraud-Shading and", 255, 0
  CSPrintShadow VIDEO, CENTERED, 60, "Matrix Calculation Demo", 255, 0
  CSPrintShadow VIDEO, 40, 100, "Arrow keys : Rotate cube around", 255, 0
  CSPrintShadow VIDEO, 40, 110, "       ESC : Exit demo", 255, 0
  CSPrintShadow VIDEO, 0, 190, CSId, 255, 0
  CSWaitKey ANYKEY

END SUB

