'----------------------------------------------------------------------------
'
' Texture-Mapping and Matrix Calculation Demo...
'
' Coded by Bobby3999 with the CosmoX Graphics Library v1.2
' E-Mail : bobby3999@yahoo.com
' Url : www.cosmosoft.cjb.net
'                                       (c) CosmoSoft 2001
'
' Compiled with QuickBasic 4.5 and CosmoX v1.2
'
' Note:
' I didn't use the library EMS calls to create the off screen layer because
' I also work on a Windows NT machine, and I can't make it to give me other
' than XMS and conventional memory.
'
'----------------------------------------------------------------------------
  DECLARE SUB ExitToDos ()
  DECLARE SUB Intro ()
  REM $INCLUDE: 'COSMOX.BI'

  TYPE FaceType
    P1 AS INTEGER             '     Used as a indexes to vertexs
    P2 AS INTEGER             '     and form a face
    P3 AS INTEGER
    P4 AS INTEGER
  END TYPE
  
  REM $DYNAMIC
  DIM SHARED Buffer%(32000), Sine!(360), Cosine!(360), Texture(8194)
  DIM SHARED Vectors(7) AS Vector3DType, VectorsT(7) AS Vector3DType
  DIM SHARED Points(7) AS Vector2DType, TMatrix!(3, 3), Matrix!(3, 3)
  DIM SHARED Pal AS STRING * 768, Faces(5) AS FaceType, Layer%
  DIM SHARED Font AS STRING * 2048, TexS%, TexO%

  DEF SEG = VARSEG(Texture(0))
  BLOAD "TEXTURE.DAT", VARPTR(Texture(0))
  DUMMY% = CSLoadPal("TEXTURE.PAL", Pal)
  Layer% = VARSEG(Buffer%(0))
  TMS% = VARSEG(TMatrix!(0, 0))
  TMO% = VARPTR(TMatrix!(0, 0))
  MS% = VARSEG(Matrix!(0, 0))
  MO% = VARPTR(Matrix!(0, 0))
  TexS% = VARSEG(Texture(0))
  TexO% = VARPTR(Texture(0))

  FOR I% = 0 TO 360
    Ang! = I% * (3.141592 / 180)
    Sine!(I%) = SIN(Ang!)
    Cosine!(I%) = COS(Ang!)
  NEXT

  FOR I% = 0 TO 7
    READ Vectors(I%).X
    READ Vectors(I%).Y
    READ Vectors(I%).z
  NEXT

  FOR I% = 0 TO 5
    READ Faces(I%).P1
    READ Faces(I%).P2
    READ Faces(I%).P3
    READ Faces(I%).P4
  NEXT

  CSInitVGA
  IF CSLoadFont("DEMO.FNT", Font) = 0 THEN CSSetFont Font
  CSSetPal Pal: CSTextureWidth 128
  DUMMY% = CSInstallKeyBoard
  CSInstallTimer
  Intro

  CSSetTimer 0, 20: CSSetTimer 1, 1000
  DO
    CSIdentityMatrix TMS%, TMO%
    CSInitRotXMatrix MS%, MO%, Cosine!(AngleX%), Sine!(AngleX%)
    CSMatrixMulMatrix TMS%, TMO%, MS%, MO%
    CSInitRotYMatrix MS%, MO%, Cosine!(AngleY%), Sine!(AngleY%)
    CSMatrixMulMatrix TMS%, TMO%, MS%, MO%

    FOR I% = 0 TO 7
      CSVectorMulMatrix VARSEG(Vectors(I%).X), VARPTR(Vectors(I%).X), TMS%, TMO%, VARSEG(VectorsT(I%).X), VARPTR(VectorsT(I%).X)
    NEXT
    FOR I% = 0 TO 7
      IF VectorsT(I%).z = 0 THEN VectorsT(I%).z = 1
      CSProjectVector VARSEG(VectorsT(I%).X), VARPTR(VectorsT(I%).X), VARSEG(Points(I%).X), VARPTR(Points(I%).X), -500
    NEXT

    CSWaitTimer 0
    FrameCount% = FrameCount% + 1
    CSPcopy Layer%, VIDEO
    CSClear Layer%, 0
    
    FOR I% = 0 TO 5
      IF CSPolyFacing(VARSEG(Points(Faces(I%).P1)), VARPTR(Points(Faces(I%).P1)), VARSEG(Points(Faces(I%).P2)), VARPTR(Points(Faces(I%).P2)), VARSEG(Points(Faces(I%).P3)), VARPTR(Points(Faces(I%).P3))) < 0 THEN
        CSTriT Layer%, Points(Faces(I%).P1).X, Points(Faces(I%).P1).Y, Points(Faces(I%).P2).X, Points(Faces(I%).P2).Y, Points(Faces(I%).P3).X, Points(Faces(I%).P3).Y, 0, 0, 127, 0, 127, 127, TexS%, TexO%
        CSTriT Layer%, Points(Faces(I%).P1).X, Points(Faces(I%).P1).Y, Points(Faces(I%).P4).X, Points(Faces(I%).P4).Y, Points(Faces(I%).P3).X, Points(Faces(I%).P3).Y, 0, 0, 0, 127, 127, 127, TexS%, TexO%
      END IF
    NEXT
    
    CSPrintShadow Layer%, CENTERED, 10, "FPS =" + STR$(FPS%), 14, 0
    CSPrintShadow Layer%, 0, 190, CSId, 14, 0
  
    IF CSTimerFlag(1) THEN FPS% = FrameCount%: FrameCount% = 0

    IF CSKey(KEYUP) THEN AngleX% = AngleX% + 1
    IF CSKey(KEYDOWN) THEN AngleX% = AngleX% - 1
    IF CSKey(KEYLEFT) THEN AngleY% = AngleY% + 1
    IF CSKey(KEYRIGHT) THEN AngleY% = AngleY% - 1
    IF AngleX% > 360 THEN AngleX% = 0
    IF AngleX% < 0 THEN AngleX% = 360
    IF AngleY% > 360 THEN AngleY% = 0
    IF AngleY% < 0 THEN AngleY% = 360
  LOOP WHILE CSKey(KEYESC) <> 1

  ExitToDos

DATA -50, 50,-50
DATA  50, 50,-50
DATA  50,-50,-50
DATA -50,-50,-50
DATA -50, 50, 50
DATA  50, 50, 50
DATA  50,-50, 50
DATA -50,-50, 50

DATA 0, 1, 2, 3
DATA 1, 5, 6, 2
DATA 5, 4, 7, 6
DATA 4, 0, 3, 7
DATA 4, 5, 1, 0
DATA 3, 2, 6, 7

SUB ExitToDos

  CSFadeTo 0, 255, 63, 63, 63
  DUMMY% = CSRemoveKeyBoard
  CSRemoveTimer
  CSInitText
  CLS
  PRINT "Texture-Mapping and Matrix Calculation Demo..."
  PRINT "Coded by Bobby3999 with the CosmoX Graphics Library v1.2"
  PRINT "E-Mail : bobby3999@yahoo.com"
  PRINT "Url : www.cosmosoft.cjb.net"
  PRINT "                                      (c) CosmoSoft 2001"
  END

END SUB

SUB Intro

  CSSpriteS VIDEO, 0, 0, 319, 199, TexS%, TexO%
  CSPrintShadow VIDEO, CENTERED, 50, "CosmoX Texture-Mapping and", 14, 0
  CSPrintShadow VIDEO, CENTERED, 60, "Matrix Calculation Demo", 14, 0
  CSPrintShadow VIDEO, 10, 100, "Arrow keys :Rotate cube around", 14, 0
  CSPrintShadow VIDEO, 10, 110, "       ESC : Exit demo", 14, 0
  CSPrintShadow VIDEO, 0, 190, CSId, 14, 0
  CSWaitKey ANYKEY

END SUB

